module(...,package.seeall)

require"ssd1306"
require "misc"
require "mqtt"
require"common"

--LCD分辨率的宽度和高度(单位是像素)
WIDTH,HEIGHT = disp.getlcdinfo()
--1个ASCII字符宽度为8像素，高度为16像素；汉字宽度和高度都为16像素
CHAR_WIDTH = 8



--[[
函数名：getxpos
功能  ：计算字符串居中显示的X坐标
参数  ：
str：string类型，要显示的字符串
返回值：X坐标
]]
function getxpos(str)
    return (WIDTH - string.len(str) * CHAR_WIDTH) / 2
end

function setcolor(color)
    if BPP~=1 then return disp.setcolor(color) end
end



--getRssi = 0
--显示信号强度
function showSingleStrength()
    local getRssi = net.getRssi()
    --getRssi = getRssi+10
    local singleStrength = 0
    if (getRssi>=0 and getRssi<=5) or (getRssi==99) then
        singleStrength = 0
    elseif getRssi>=6 and getRssi<=10 then
        singleStrength = 1
    elseif getRssi>=11 and getRssi<=16 then
        singleStrength = 2
    elseif getRssi>=17 and getRssi<=22 then
        singleStrength = 3
    elseif getRssi>=23 and getRssi<=27 then
        singleStrength = 4
    elseif getRssi>=28 and getRssi<=31 then
        singleStrength = 5
    end

    disp.drawrect(0,0,30,15,0x0)--先把当前显示的信号强度清除掉
    disp.putimage("/ldata/single5.bmp",0,0,-1,0,0,29-(5-singleStrength)*4,14)--显示信号5格
    --disp.putimage("/ldata/line_off.bmp",42,5)--显示在线标志

    log.info("singleStrength",singleStrength)

end


--[[
sys.taskInit(function()
    while true do
        showSingleStrength()
        disp.update()
        sys.wait(10000)
    end
end)
]]

sys.taskInit(
    function()
        
        local str1 = "系统联网中"
        local str2 = "请稍后片刻"
        disp.puttext(common.utf8ToGb2312(str1),getxpos(common.utf8ToGb2312(str1)),14)
        disp.puttext(common.utf8ToGb2312(str2),getxpos(common.utf8ToGb2312(str2)),32)
        disp.update()        
        while true do
            if socket.isReady() then
                disp.clear()
                disp.update()  
                while true do
                    showSingleStrength()
                     str1 = "我是老张"
                     str2 = "10秒更新一次"
                    disp.puttext(common.utf8ToGb2312(str1),getxpos(common.utf8ToGb2312(str1)),28)
                    disp.puttext(common.utf8ToGb2312(str2),getxpos(common.utf8ToGb2312(str2)),47)                    
                    disp.update()
                    sys.wait(10000)
                end
            else
                log.info("socket is not ready!!!!!!!!!")
                sys.wait(1000)
            end
        end
    end
)
